/*

reinhard@finalmedia.de
Mo 27. Feb 17:26:02 CET 2023
Mi 3. Mai 21:01:23 CEST 2023	fixed false call of file close on eaccess fail

read from stdin line by line

search for first space character.
extract name before first space characters as filename string
and write the rest of line to file named by this filename string.
placing this file in given targetdir.
and cloning the line to stdout, if file was successfully written.

example:

echo "data.txt 82739623487263487236482736" | writelinefile | ...

since the stream a stdin contains theses lines:
targetdir/data.txt 82739623487263487236482736
abcd/data2.txt 28777732392783273872873271
the content "82739623487263487236482736" is written to a file named "targetdir/data.txt" and
the content "28777732392783273872873271" is written to a file named "abcd/data2.txt"

+++ SECURITY ADVISORY +++

be aware, that

- given filename/path MAY NOT CONTAIN ANY SPACE CHARACTER!!
- given filename may be ANY full path in filesystem!
use sandboxing with cgroups, chroot, unshare to jail the process to a specific basepath.
- also be aware to remove write permission to writelinefile itself,
if it is in your chroot! you can also set immutable flag to binary, if your filesystem supports
this: chattr +i writelinefile

- use umask 022 before call of wirelinefile,
so files gets written with permission 0600 and wont be executable.

*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>

int main() {

/* space char is separator character */
static char separator=' ';

while(1) {

	char *line = NULL;
	size_t len=0;

	if (getline(&line, &len, stdin)!=-1) {

		char *token_ptr = NULL;

		/* point to address of fist occuring separator character in current line */
		token_ptr = strchr(line,separator);

		if (token_ptr!=NULL) { /* if found */

			/* extract filename by replacing separator character with null byte */
			*token_ptr='\0';

			FILE *f;

			f = fopen(line, "w");

			/* reset to full line */
			*token_ptr=separator;


			if (f!=NULL) { /* if file opened for writing */

				/* write content to file. if successful, then also clone line to stdout */
                		if (fprintf(f,"%s",token_ptr+1)) { printf(token_ptr+1); }

				fclose(f);

                	}


		}

	/* zero entire content and free */
	memset(line,0,len);
       	free(line);

        } else { return 0; }

}

return 0;
}
